/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-touch-skill-msgs-0.0.1-0quantal-20150414-0715/msg/TouchInfo.msg
 *
 */


#ifndef TOUCH_SKILL_MSGS_MESSAGE_TOUCHINFO_H
#define TOUCH_SKILL_MSGS_MESSAGE_TOUCHINFO_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace touch_skill_msgs
{
template <class ContainerAllocator>
struct TouchInfo_
{
  typedef TouchInfo_<ContainerAllocator> Type;

  TouchInfo_()
    : last_update()
    , touched_parts()  {
    }
  TouchInfo_(const ContainerAllocator& _alloc)
    : last_update()
    , touched_parts(_alloc)  {
    }



   typedef ros::Time _last_update_type;
  _last_update_type last_update;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _touched_parts_type;
  _touched_parts_type touched_parts;




  typedef boost::shared_ptr< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct TouchInfo_

typedef ::touch_skill_msgs::TouchInfo_<std::allocator<void> > TouchInfo;

typedef boost::shared_ptr< ::touch_skill_msgs::TouchInfo > TouchInfoPtr;
typedef boost::shared_ptr< ::touch_skill_msgs::TouchInfo const> TouchInfoConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::touch_skill_msgs::TouchInfo_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace touch_skill_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'touch_skill_msgs': ['/tmp/buildd/ros-hydro-touch-skill-msgs-0.0.1-0quantal-20150414-0715/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
{
  static const char* value()
  {
    return "686289b8b1159bd7bed550099cfd8273";
  }

  static const char* value(const ::touch_skill_msgs::TouchInfo_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x686289b8b1159bd7ULL;
  static const uint64_t static_value2 = 0xbed550099cfd8273ULL;
};

template<class ContainerAllocator>
struct DataType< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
{
  static const char* value()
  {
    return "touch_skill_msgs/TouchInfo";
  }

  static const char* value(const ::touch_skill_msgs::TouchInfo_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#\n\
# \n\
#\n\
\n\
time last_update\n\
string[] touched_parts\n\
";
  }

  static const char* value(const ::touch_skill_msgs::TouchInfo_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.last_update);
      stream.next(m.touched_parts);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct TouchInfo_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::touch_skill_msgs::TouchInfo_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::touch_skill_msgs::TouchInfo_<ContainerAllocator>& v)
  {
    s << indent << "last_update: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.last_update);
    s << indent << "touched_parts[]" << std::endl;
    for (size_t i = 0; i < v.touched_parts.size(); ++i)
    {
      s << indent << "  touched_parts[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.touched_parts[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // TOUCH_SKILL_MSGS_MESSAGE_TOUCHINFO_H
